let handleRenderError = (() => {
	var _ref5 = _asyncToGenerator(function* ({ error, context, file }) {
		const notFound = notFoundRegex.test(error.message);

		context.body = error.message;

		if (notFound) {
			console.log('404 Not found:', file);
			context.status = 404;
		} else {
			console.log(error);
			context.status = 500;
		}
	});

	return function handleRenderError(_x9) {
		return _ref5.apply(this, arguments);
	};
})();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const url = require('url');

const Router = require('koa-router');

const notFoundRegex = /returned status 404/;

const defaultAssetExtensionsToServeFromContentUrl = ['jpg', 'jpeg', 'gif', 'png'];
module.exports = function ({
	butler,
	assetsUrl,
	lazyRender,
	nonMarkdownContentUrl,
	assetExtensionsToServeFromContent = defaultAssetExtensionsToServeFromContentUrl
}) {

	const router = Router();
	const getLastModified = makeLastModifiedWatcher({ butler });

	function setContentHeaders(context) {
		context.set('Cache-Control', 'public, must-revalidate');
		context.set('Last-Modified', getLastModified().toUTCString());
	}

	router.get('/', (() => {
		var _ref = _asyncToGenerator(function* (context, next) {
			const file = 'index.md';

			setContentHeaders(context);

			if (context.stale) {
				const renderPromise = lazyRender({ file });

				yield next();

				try {
					context.body = yield renderPromise;
				} catch (error) {
					yield handleRenderError({ error, context, file });
				}
			}
		});

		return function (_x, _x2) {
			return _ref.apply(this, arguments);
		};
	})());

	router.get('/assets/:path(.+)', (() => {
		var _ref2 = _asyncToGenerator(function* (context, next) {
			const { path } = context.params;

			const redirectTo = url.resolve(assetsUrl, path);

			context.status = 301;
			context.set('Location', redirectTo);
		});

		return function (_x3, _x4) {
			return _ref2.apply(this, arguments);
		};
	})());

	router.get(`/:path(.+\\.md)`, (() => {
		var _ref3 = _asyncToGenerator(function* (context, next) {
			const { path } = context.params;

			const file = decodeURIComponent(path);
			const query = context.query;

			setContentHeaders(context, file);

			if (context.stale) {
				const renderPromise = lazyRender({
					file,
					sessionData: { parameters: query },
					key: context.search || '?'
				});

				yield next();

				try {
					context.body = yield renderPromise;
				} catch (error) {
					yield handleRenderError({ lazyRender, error, context, file });
				}
			}
		});

		return function (_x5, _x6) {
			return _ref3.apply(this, arguments);
		};
	})());

	const extensionPattern = assetExtensionsToServeFromContent.join('|');

	router.get(`/:path(.+\\.):extension(${extensionPattern})`, (() => {
		var _ref4 = _asyncToGenerator(function* (context, next) {
			const { path, extension } = context.params;

			const redirectTo = url.resolve(nonMarkdownContentUrl, path + extension);

			context.status = 301;
			context.set('Location', redirectTo);
		});

		return function (_x7, _x8) {
			return _ref4.apply(this, arguments);
		};
	})());

	return router;
};

function makeLastModifiedWatcher({ butler }) {
	let lastModified = new Date();

	function resetLastModified() {
		lastModified = new Date();
	}

	butler.on('post changed', resetLastModified);
	butler.on('index changed', resetLastModified);

	return () => lastModified;
}
